//  ..  2006.
// a_biv @ list . ru   
#include <pic.h>
#include "delay_a.h"
__CONFIG (INTIO & UNPROTECT & LVPDIS & BORDIS & MCLREN & PWRTEN & WDTDIS);
///////////    /////////////////////
bit	Sio		    @ (unsigned)&PORTB*8+3 ; // .
bit	Sck		    @ (unsigned)&PORTB*8+2 ; // .
bit	CS		    @ (unsigned)&PORTB*8+1 ; //  .
bit	Key_On	    @ (unsigned)&PORTB*8+0 ; // .
bit	Katod_0	    @ (unsigned)&PORTB*8+7 ; //   .
bit	Katod_1	    @ (unsigned)&PORTB*8+6 ; // 
bit	Katod_2	    @ (unsigned)&PORTB*8+5 ; // 
bit	Katod_3	    @ (unsigned)&PORTB*8+4 ; //   .
//////////    ////////////////////
volatile unsigned int Over_10mS; //   TMR0. 10 . ( 655.35 ).
volatile unsigned char Key_Count; //   .
volatile unsigned int Tem[5]; //  . Tem[4] -   
unsigned char Index;
volatile bit Znak = 0;  //   1 - "-", 0 - "+"
const unsigned char Str_Led[]= { //  
 //   gb cdefa
	0b10100000,	 // "0" [0]
	0b10101111,	 // "1"
	0b00110010,	 // "2"
	0b00100110,	 // "3"
	0b00101101,	 // "4"
	0b01100100,	 // "5"
	0b01100000,	 // "6"
	0b10101110,	 // "7"
	0b00100000,	 // "8"
	0b00100100,	 // "9"
	0b11111111}; // " " [10]
//********************************************************************************
/////////////////  ////////////////////////////
void Measure(void) {
	unsigned char i = 0;
	signed int s = 0;
	unsigned int k = 0;
	PORTA = 0xFF; //  
	Sck = 0;
	TRISB3 = 1; // SIO  
 	CS = 0; //   
	while (i < 13){ // 13  
		DelayUs(150);
		s = s << 1 ; //	  	
		if (Sio == 1) s |= 0b1000; // .  
		Sck = 1;
		DelayUs(150);
		Sck = 0;
		i++;
	}
	TRISB3 = 0; // SIO  
	CS = 1; //   
	s = s / 8; // 16 -> 13
	s = s - 10;	//  (  ) (  36.6)
	if (s < 0){//   
		Znak = 1;
		s = s * -1; 
	} else Znak = 0;
	k = (float)s * 0.625; //    
	for (i=4; i>=1; i--){ //   - 
		Tem[i] = k % 10;
		k = k / 10;
	}
	if (Tem[1]==0) { //    
		Tem[1] = 10; // 
		if (Tem[2]==0) {
			Tem[2] = 10; // 
		}
	}
	for (i=4; i>=1; i--){ //    
		Tem[i] = Str_Led[Tem[i]];
	}
	if (Znak==1) Tem[1] &= 0b01111111; // "" 
}
/////////////////  ////////////////////////////
void interrupt Int0_TMR0_10ms(void) {
	if (INTF == 0){
		TMR0 = 256 - 156;  //   156  .
		T0IF = 0;
		Over_10mS++;
		if ((Over_10mS & 0b0000000000111111) == 0) Measure(); // 320 mS
		if ((Key_On == 0) && (Key_Count < 250)) Key_Count++; //  
			else Key_Count = 0;
		if (Over_10mS >= 18000) Key_Count = 250; //    180.00 / 60 = 3
	} else INTF = 0;
}
/////////////////   ////////////////////////
void main(void){
ReStart:
	Key_Count = 0; Over_10mS = 0;
	INTCON = PIE1 = 0;  //    
	PEIE = 1;   //  
	TRISA = 0; TRISB = 0b00001001;
	PORTA = PORTB = 0;
	Index = 0;
	while (Index < 33){ // 77 - 
		if (Index == 16){
			TRISB3 = 0; // SIO  
			asm("nop");
			Sio = 0;
		}
		DelayUs(150);
		Sck = 1;
		DelayUs(150);
		Sck = 0;
		Index++;
	}
	CS = 1; //   
	OPTION = 0b00000101; // ,  RB0  ,
	CMCON = 0b00000111; //  
	VRCON = 0;  // OFF. 
	CCP1CON = 0; // 
	SPBRG = 25;	//  9600 bod.  4 MHz.  USART
	RCSTA = 0b00010000; TXSTA = 0b00100110;  // 8-N-1 Async UART    OFF!!
	T2CON = 0b00000000; // 
	T1CON = 0b00000000; //  - 4MHz/4/1/65536 = 65536 mks. Off.
	DelayMs(10);
	Tem[0] = Tem[1] = Tem[2] = Tem[3] = Tem[4] = 0; //  
	TMR0 = 100; // 4MHz/4/64/256 = 16384, 1=64. 256-100=15664=9984
	PIR1 = 0; INTCON &= 0b11111000; //   
	T0IE = 1;
	ei(); //  .   --------------------------------------------------
	while(1){  //  

		PORTA = Tem[4]; //  
		Katod_3 = 1; //  .
		DelayMs(2); // 
		Katod_3 = 0; //  .

		PORTA = Tem[3]; //  
		Katod_2 = 1; //  .
		DelayMs(2); // 
		Katod_2 = 0; //  .

		PORTA = Tem[2]; //  
		Katod_1 = 1; //  .
		DelayMs(2); // 
		Katod_1 = 0; //  .

		PORTA = Tem[1]; //  
		Katod_0 = 1; //  .
		DelayMs(2); // 
		Katod_0 = 0; //  .

		if (Key_Count > 10){ // 
			TRISB = 0b00001001; // SIO  
			T0IE = 0;
			Index = 0;
			PORTA = PORTB = 0;
			while (Key_On == 0){}
 			CS = 0;	//               TC77 
			while (Index < 33){
				if (Index == 16){
					TRISB3 = 0; // SIO  
					asm("nop");
					Sio = 1;
				}
				DelayUs(150);
				Sck = 1;
				DelayUs(150);
				Sck = 0;
				Index++;
			}
			Sio = 0; CS = 1;  //   
			DelayMs(10);
ReSleep:
			INTF = 0; INTE = 1;
			asm("sleep"); // 
			asm("nop");
			DelayMs(100);
			if (Key_On == 1) goto ReSleep;
			while (Key_On == 0){} //   
			goto ReStart;
		}
	}  // end loopen
} //*********************************************************************************************
